//================================================================================
// PHC-25  SSAVE č p6 f[^oCiC[Wo
//
//--------------------------------------------------------------------------------
// '2004.04.10 Ver.1.00 J
// '2004.03.28 쐬Jn
//================================================================================
#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define TITLE "p6tophc25bin"
#define PROG  "p6_phc25"
#define VER   "1.00"
#define OPTION_HELP 0x00000001

int main( int argc, char* argv[] )
{
	char path1[ 260 ];
	char path2[ 260 ];
	unsigned int option;
	int i;
	// IvV擾
	option = 0;
	path1[ 0 ] = '\0';
	path2[ 0 ] = '\0';
	if( argc > 1 )
	{
		for( i = 1; i < argc; i ++ )
		{
			if( ( '/' == argv[i][0] ) || ( '-' == argv[i][0] ) )
			{
				if( 0 == strnicmp( &argv[i][1], "HELP", 4 ) )
				{
					option |= OPTION_HELP;
				}
				else if( 0 == strnicmp( &argv[i][1], "?", 1 ) )
				{
					option |= OPTION_HELP;
				}
			}
			else
			{
				if( '\0' == path1[ 0 ] )
				{
					strcpy( path1, argv[ i ] );
				}
				else if( '\0' == path2[ 0 ] )
				{
					strcpy( path2, argv[ i ] );
				}
			}
		}
	}
	else
	{
		option |= OPTION_HELP;
	}
	if( ( '\0' == path1[ 0 ] ) || ( '\0' == path2[ 0 ] ) )
	{
		option |= OPTION_HELP;
	}
	// IvVƂ̏s
	if ( option & OPTION_HELP ) {
		// g\
		printf( TITLE " \'" PROG "\' " "Ver." VER " by TAGO\n" );
		printf( "Usage  : " PROG " [/Option] [p6 file] [outfile]\n" );
		printf( "Option\n" );
		printf( "         /HELP     Display help\n" );
		printf( "         /?        Display help\n" );
		return 0;
	}
	// f[^ǂݍ
	FILE *file;
	int size;
	char *data;
	char outdata[ 1024 * 6 ];
	file = fopen( path1, "rb" );
	if( NULL == file )
	{
		return 1;
	}
	fseek( file, 0, SEEK_END );
	size = ftell( file );
	size = size;
	fseek( file, 0, SEEK_SET );
	data = new char[ size ];
	fread( data, size, 1, file );
	fclose( file );
	// f[^ϊ
	char *analyze;
	int out_index;
	int count_3c;
	bool write_start = false;
	analyze = data;
	out_index = 0;
	count_3c = 0;
	while( 1 )
	{
		if( *analyze == 0x3C )
		{
			count_3c ++;
			if( 6 == count_3c )
			{
				if( false == write_start )
				{
					write_start = true;
					count_3c = 0;
				}
				else
				{
					// Rs[
					memcpy( &outdata[ out_index ], analyze + 1, 128 );
					count_3c = 0;
					analyze += 128;
					out_index += 128;
					if( out_index >= 1024 * 6 )
					{
						break;
					}
				}
			}
		}
		else
		{
			count_3c = 0;
		}
		analyze ++;
	}
	// 
	file = fopen( path2, "wb" );
	if( NULL == file )
	{
		return 1;
	}
	fwrite( outdata, 1024 * 6, 1, file );
	fclose( file );
	return 0;
}
